package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.ConfTotemDAO;
import com.rjconsultores.ventaboletos.entidad.ConfTotem;

/**
 * 
 * @author Wallace
 */
@Repository("confTotemDAO")
public class ConfTotemHibernateDAO extends GenericHibernateDAO<ConfTotem, Integer>
		implements ConfTotemDAO {

	@Autowired
	public ConfTotemHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<ConfTotem> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	public ConfTotem buscar(String chave) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		c.add(Restrictions.ilike("chave", chave));

		return c.list().isEmpty() ? null : (ConfTotem) c.list().get(0);
	}
}